#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "reporter.h"
#include "audio.h"


void
on_comment_text_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{
  status_text( "" );

}


void
on_language_menu_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  status_text( "" );

}


void
on_priority_menu_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  status_text( "" );

}


void
on_topic_menu_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  status_text( "" );

}


void
on_oneday_radio_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  status_text( "" );

  if( gtk_toggle_button_get_active( togglebutton ) ) {
    expiredelta = 60*60*24;
  }
}


void
on_threeday_radio_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  status_text( "" );

  if( gtk_toggle_button_get_active( togglebutton ) ) {
    expiredelta = 60*60*24*3;
  }
}


void
on_oneweek_radio_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  status_text( "" );

  if( gtk_toggle_button_get_active( togglebutton ) ) {
    expiredelta = 60*60*24*7;
  }
}


void
on_twoweek_radio_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  status_text( "" );

  if( gtk_toggle_button_get_active( togglebutton ) ) {
    expiredelta = 60*60*24*14;
  }
}


void
on_monitor_button_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if( gtk_toggle_button_get_active( togglebutton ) ) {
    start_monitor();
  } else {
    stop_monitor();
  }
}


void
on_play_button_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if( gtk_toggle_button_get_active( togglebutton ) ) {
    start_play();
  } else {
    stop_play();
  }

}


void
on_rec_button_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  status_text( "" );
  if( gtk_toggle_button_get_active( togglebutton ) ) {
    start_record();
  } else {
    stop_record();
  }

}


void
on_new_button_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  clear();

}


void
on_broadcast_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  broadcast();

}


gboolean
on_composer_delete_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  cleanup_audio();
  cleanup();
  gtk_exit( 0 );

  return FALSE;
}

