<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xsl:version="1.0">

  <xsl:output method="html"/>
  
  <xsl:template match="/">
    <html>
      <head>
        <title>MPN: news</title>
      </head>
      <body>
        <h1>MPN: news</h1>

        <hr/>
        <a href="prefs.xml">prefs</a> | 
        <a href="published.xml">published</a> |
        <a href="news.xml">news</a> ||
        <a href="http://matrix.wearlab.de">matrix.wearlab.de</a>
        <hr/>

	<xsl:apply-templates/>
      </body>
    </html>
  </xsl:template>

  <xsl:template match="news">
    <h3><xsl:value-of select="sig/subject"/></h3>
    <table border="5" width="100%">
      <xsl:apply-templates/>
    </table>
  </xsl:template>

  <xsl:template match="subject">
  </xsl:template>

  <xsl:template match="location">
    <tr><td>Location: </td><td><xsl:apply-templates/></td></tr>
  </xsl:template>

  <xsl:template match="id">
    <tr><td>ID: </td><td><xsl:apply-templates/></td></tr>
  </xsl:template>

  <xsl:template match="author">
    <tr>
      <td>
        Author<br/>
        <a>
          <xsl:attribute name="href">
            matrix://|addfriend|<xsl:value-of select="name"/>|<xsl:value-of select="home"/>
          </xsl:attribute>
          add to friends
        </a>
      </td>
      <td><table border="0">
        <xsl:apply-templates/>
      </table></td>
    </tr>
  </xsl:template>
  <xsl:template match="author/name">
    <tr><td>Name: </td><td><xsl:apply-templates/></td></tr>
  </xsl:template>
  <xsl:template match="author/home">
    <tr><td>Home: </td><td><xsl:apply-templates/></td></tr>
  </xsl:template>

  <xsl:template match="file">
  </xsl:template>

  <xsl:template match="publish_time">
    <xsl:if test="txt">
      <tr><td>Publish Date: </td><td><xsl:value-of select="txt"/></td></tr>
    </xsl:if>
    <xsl:if test="not(txt)">
      <xsl:apply-templates/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="publish_time/sec">
    <tr><td>Publish Date (in sec. since 1970): </td><td><xsl:apply-templates/></td></tr>
  </xsl:template>  

  <xsl:template match="expire">
    <xsl:if test="txt">
      <tr><td>Expire Date: </td><td><xsl:value-of select="txt"/></td></tr>
    </xsl:if>
    <xsl:if test="not(txt)">
      <xsl:apply-templates/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="expire/sec">
    <tr><td>Expire Date (in sec. since 1970): </td><td><xsl:apply-templates/></td></tr>
  </xsl:template>  

  <xsl:template match="ttl">
    <tr><td>TTL: </td><td><xsl:apply-templates/></td></tr>
  </xsl:template>
    
  <xsl:template match="hop">
    <tr><td>hop count: </td><td><xsl:apply-templates/></td></tr>
  </xsl:template>
    
  <xsl:template match="weight">
    <tr><td>Weight: </td><td><xsl:apply-templates/></td></tr>
  </xsl:template>

  <xsl:template match="localfile">
    <tr><td>Localfile: </td><td><xsl:apply-templates/></td></tr>
  </xsl:template>
    
  <xsl:template match="/*/*/app/*">
    <tr>
      <td><xsl:value-of select="name()"/></td>
      <td><table border="0">
        <xsl:apply-templates/>
      </table></td>
    </tr>
  </xsl:template>
  <xsl:template match="/*/*/app/*/*">
    <tr><td><xsl:value-of select="name()"/>:</td><td><xsl:apply-templates/></td></tr>
  </xsl:template>

</xsl:stylesheet>




