/*
** Copyright (C) 2002 Tom Nicolai <nicolai@tzi.de>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

//#ifdef HAVE_CONFIG_H
//#include "../config.h"
//#endif

#include <xmms/plugin.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include <pthread.h>
#include <mpn/matrix.h>
#include "mixin.h"


#define PLUGIN_VERSION "0.3"

pthread_t fetch_thread_id;

static void init(void);
static void cleanup(void);
static void about(void);
static void configure(void);
static int mod_samples(gpointer *d, gint length, AFormat afmt, 
		       gint srate, gint nch);

EffectPlugin matrixnews_ep =
{
  NULL,
  NULL,
  NULL, /* Description */
  init,
  cleanup,
  about,
  configure,
  mod_samples
};

//static const char *about_text = N_("Matrix News Plugin\n\n"
//				   "By [wearLab].");

static GtkWidget *conf_dialog = NULL;

// For mod_samples Callback
#define PHASE_IDLE     0
#define PHASE_PLAYNEWS 1
#define PHASE_FADEOUT  2
#define PHASE_FADEIN   3
static int phase;
static double fader;

//#define IDLE_WAIT 1000
//static int idlecount;


EffectPlugin *get_eplugin_info(void)
{
  //matrixnews_ep.description =
  //  g_strdup_printf(_("Matrix News Plugin %s"), VERSION);
  matrixnews_ep.description =
    g_strdup_printf( "Matrix News Plugin %s", PLUGIN_VERSION);
  return &matrixnews_ep;
}

static void init(void)
{
  phase = PHASE_IDLE;
  //idlecount = 100; 

  mpn_init();
  mixin_init();
  pthread_create( &fetch_thread_id, NULL, fetch_thread, NULL );
}

static void cleanup(void)
{
  mixin_cleanup();
  mpn_cleanup();
}

static void about(void)
{
  /*
  static GtkWidget *about_dialog = NULL;
	
  if (about_dialog != NULL)
    return;

  about_dialog = xmms_show_message(_("About Matrix News Plugin"),
				   _(about_text), _("Ok"), FALSE,
				   NULL, NULL);
  gtk_signal_connect(GTK_OBJECT(about_dialog), "destroy",
		     GTK_SIGNAL_FUNC(gtk_widget_destroyed),
		     &about_dialog);
  */
}

static void conf_ok_cb(GtkButton * button, gpointer data)
{
  /*
  ConfigFile *cfg;

  value = *(gfloat *) data;
	
  cfg = xmms_cfg_open_default_file();
  xmms_cfg_write_float(cfg, "matrixnews", "intensity", value);
  xmms_cfg_write_default_file(cfg);
  xmms_cfg_free(cfg);
  gtk_widget_destroy(conf_dialog);
  */
}

static void conf_cancel_cb(GtkButton * button, gpointer data)
{
  /*
  gtk_widget_destroy(conf_dialog);
  */
}

static void conf_apply_cb(GtkButton *button, gpointer data)
{
  /*
  value = *(gfloat *) data;
  */
}

static void configure(void)
{
  /*
  GtkWidget *hbox, *label, *scale, *button, *bbox;
  GtkObject *adjustment;
  
  if (conf_dialog != NULL)
    return;
  
  conf_dialog = gtk_dialog_new();
  gtk_signal_connect(GTK_OBJECT(conf_dialog), "destroy",
		     GTK_SIGNAL_FUNC(gtk_widget_destroyed), &conf_dialog);
  gtk_window_set_title(GTK_WINDOW(conf_dialog), _("Configure Matrix News"));
  
  label = gtk_label_new(_("Matrix intensity:"));
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(conf_dialog)->vbox), label,
		     TRUE, TRUE, 0);
  gtk_widget_show(label);
  
  hbox = gtk_hbox_new(FALSE, 10);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(conf_dialog)->vbox), hbox,
		     TRUE, TRUE, 10);
  gtk_widget_show(hbox);
  
  adjustment = gtk_adjustment_new(value, 0.0, 15.0 + 1.0, 0.1, 1.0, 1.0);
  scale = gtk_hscale_new(GTK_ADJUSTMENT(adjustment));
  gtk_box_pack_start(GTK_BOX(hbox), scale, TRUE, TRUE, 10);
  gtk_widget_show(scale);
  
  bbox = gtk_hbutton_box_new();
  gtk_button_box_set_layout(GTK_BUTTON_BOX(bbox), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing(GTK_BUTTON_BOX(bbox), 5);
  gtk_box_pack_start(GTK_BOX((GTK_DIALOG(conf_dialog)->action_area)),
		     bbox, TRUE, TRUE, 0);
  
  button = gtk_button_new_with_label(_("Ok"));
  GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
  gtk_box_pack_start(GTK_BOX(bbox), button, TRUE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(conf_ok_cb),
		     &GTK_ADJUSTMENT(adjustment)->value);
  gtk_widget_grab_default(button);
  gtk_widget_show(button);
  
  button = gtk_button_new_with_label(_("Cancel"));
  GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
  gtk_box_pack_start(GTK_BOX(bbox), button, TRUE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(conf_cancel_cb), NULL);
  gtk_widget_show(button);
  
  button = gtk_button_new_with_label(_("Apply"));
  GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
  gtk_box_pack_start(GTK_BOX(bbox), button, TRUE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(conf_apply_cb),
		     &GTK_ADJUSTMENT(adjustment)->value);
  gtk_widget_show(button);
  
  gtk_widget_show(bbox);
  
  gtk_widget_show(conf_dialog);
  */
}

static int mod_samples( gpointer *d, gint length, AFormat afmt, 
			gint srate, gint nch )
{
  int r, i;
  signed short* dest;
  double fa;

  if (!(afmt == FMT_S16_NE ||
	(afmt == FMT_S16_LE && G_BYTE_ORDER == G_LITTLE_ENDIAN) ||
	(afmt == FMT_S16_BE && G_BYTE_ORDER == G_BIG_ENDIAN)) )
    return length;

  if( phase==PHASE_IDLE ) {
    /*
    if( --idlecount>0 ) {
      return length;

    } else {
      idlecount = IDLE_WAIT;
    */
      if( samples_available() ) {
	phase = PHASE_FADEOUT;
	fader = 1.0;
	//printf( "New news available: %d\n", message_list.len );
      }
      //}
  }

  else if( phase==PHASE_FADEOUT ) {

    dest = (signed short*)*d;
    for( i=0; i<length/2; i++ ) {
      fader-=0.00001;
      fa = fader; if( fa<0.0 ) fa=0.0;
      dest[i] = (signed short)(((double)dest[i])*fa);
    }
    if( fader <= -0.5 ) {
      phase = PHASE_PLAYNEWS;
    }
  }
    
  else if( phase==PHASE_FADEIN ) {

    dest = (signed short*)*d;
    for( i=0; i<length/2; i++ ) {
      fader+=0.00001;
      fa = fader; 
      if( fa>1.0 ) fa=1.0;
      if( fa<0.0 ) fa=0.0;
      dest[i] = (signed short)(((double)dest[i])*fa);
    }
    if( fader >= 1.0 ) {
      phase = PHASE_IDLE;
      //idlecount = IDLE_WAIT;
    }
  }
    
  else if( phase==PHASE_PLAYNEWS ) {

    r = get_samples( (char*)*d, length, afmt, srate, nch );

    if( r<length ) {

      dest = (signed short*)*d;
      for( i=r/2; i<length/2; i++ ) {
	dest[i] = 0;
      }

      //printf( "News finished\n" );
      phase = PHASE_FADEIN;
      fader = -0.5;
    }
  }

  return length;
}







